// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockEnvironmentRules is an autogenerated mock type for the EnvironmentRules type
type MockEnvironmentRules struct {
	mock.Mock
}

// CreateEnvironmentRule provides a mock function with given fields: ctx, req
func (_m *MockEnvironmentRules) CreateEnvironmentRule(ctx context.Context, req *models.EnvironmentRule) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, req)

	if len(ret) == 0 {
		panic("no return value specified for CreateEnvironmentRule")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.EnvironmentRule) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, req)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.EnvironmentRule) *models.EnvironmentRule); ok {
		r0 = rf(ctx, req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.EnvironmentRule) error); ok {
		r1 = rf(ctx, req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteEnvironmentRule provides a mock function with given fields: ctx, rule
func (_m *MockEnvironmentRules) DeleteEnvironmentRule(ctx context.Context, rule *models.EnvironmentRule) error {
	ret := _m.Called(ctx, rule)

	if len(ret) == 0 {
		panic("no return value specified for DeleteEnvironmentRule")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.EnvironmentRule) error); ok {
		r0 = rf(ctx, rule)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetEnvironmentRuleByID provides a mock function with given fields: ctx, id
func (_m *MockEnvironmentRules) GetEnvironmentRuleByID(ctx context.Context, id string) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRuleByID")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.EnvironmentRule); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentRuleByPRN provides a mock function with given fields: ctx, prn
func (_m *MockEnvironmentRules) GetEnvironmentRuleByPRN(ctx context.Context, prn string) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRuleByPRN")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.EnvironmentRule); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetEnvironmentRules provides a mock function with given fields: ctx, input
func (_m *MockEnvironmentRules) GetEnvironmentRules(ctx context.Context, input *GetEnvironmentRulesInput) (*EnvironmentRulesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetEnvironmentRules")
	}

	var r0 *EnvironmentRulesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentRulesInput) (*EnvironmentRulesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetEnvironmentRulesInput) *EnvironmentRulesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*EnvironmentRulesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetEnvironmentRulesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateEnvironmentRule provides a mock function with given fields: ctx, rule
func (_m *MockEnvironmentRules) UpdateEnvironmentRule(ctx context.Context, rule *models.EnvironmentRule) (*models.EnvironmentRule, error) {
	ret := _m.Called(ctx, rule)

	if len(ret) == 0 {
		panic("no return value specified for UpdateEnvironmentRule")
	}

	var r0 *models.EnvironmentRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.EnvironmentRule) (*models.EnvironmentRule, error)); ok {
		return rf(ctx, rule)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.EnvironmentRule) *models.EnvironmentRule); ok {
		r0 = rf(ctx, rule)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.EnvironmentRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.EnvironmentRule) error); ok {
		r1 = rf(ctx, rule)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockEnvironmentRules creates a new instance of MockEnvironmentRules. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockEnvironmentRules(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockEnvironmentRules {
	mock := &MockEnvironmentRules{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
